
require 'test/unit/testcase'
require 'bruby'

class BRbTestCase < Test::Unit::TestCase

  def verify(name)
     rbfile  = 'src/' + name + '.rb'
     rbbfile = 'bin/' + name + '.rbb'

     if BRb.verifyfile(rbfile)
       File.open(rbbfile, 'wb') { |file|
         file.print(BRb.dumpfile(rbfile))
       }

       return exec_ruby(rbfile) == exec_bruby(rbbfile)
     else
       return false
     end
  end

  def exec_ruby(file)
    return `ruby #{file}`
  end

  def exec_bruby(file)
    return `ruby -r bruby -e 'BRb.loadfile("#{file}")'`
  end

end
